# swagger-petstore

SwaggerPetstore - JavaScript client for swagger-petstore

Version: 1.0.0

Automatically generated by the JavaScript Swagger Codegen project:

- Build date: 2016-03-16T19:41:06.099+08:00
- Build package: class io.swagger.codegen.languages.JavascriptClientCodegen

## Installation

### Use in [Node.js](https://nodejs.org/)

The generated client is valid [npm](https://www.npmjs.com/) package, you can publish it as described
in [Publishing npm packages](https://docs.npmjs.com/getting-started/publishing-npm-packages).

After that, you can install it into your project via:

```shell
npm install swagger-petstore --save
```

You can also host the generated client as a git repository on github, e.g.
https://github.com/YOUR_USERNAME/swagger-petstore

Then you can install it via:

```shell
npm install YOUR_USERNAME/swagger-petstore --save
```

### Use in browser with [browserify](http://browserify.org/)

The client also works in browser environment via npm and browserify. After following
the above steps with Node.js and installing browserify with `npm install -g browserify`,
you can do this in your project (assuming *main.js* is your entry file):

```shell
browserify main.js > bundle.js
```

The generated *bundle.js* can now be included in your HTML pages.

## Getting Started

```javascript
var SwaggerPetstore = require('swagger-petstore');

var defaultClient = SwaggerPetstore.ApiClient.default;
defaultClient.timeout = 10 * 1000;
defaultClient.defaultHeaders['Test-Header'] = 'test_value';

// Assuming there's a `PetApi` containing a `getPetById` method
// which returns a model object:
var api = new SwaggerPetstore.PetApi();
api.getPetById(2, function(err, pet, resp) {
  console.log('HTTP status code: ' + resp.status);
  console.log('Response Content-Type: ' + resp.get('Content-Type'));
  if (err) {
    console.error(err);
  } else {
    console.log(pet);
  }
});
```

## Documentation for API Endpoints

All URIs are relative to *http://petstore.swagger.io/v2*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*SwaggerPetstore.PetApi* | [**addPet**](docs/PetApi.md#addPet) | **POST** /pet | Add a new pet to the store
*SwaggerPetstore.PetApi* | [**addPetUsingByteArray**](docs/PetApi.md#addPetUsingByteArray) | **POST** /pet?testing_byte_array=true | Fake endpoint to test byte array in body parameter for adding a new pet to the store
*SwaggerPetstore.PetApi* | [**deletePet**](docs/PetApi.md#deletePet) | **DELETE** /pet/{petId} | Deletes a pet
*SwaggerPetstore.PetApi* | [**findPetsByStatus**](docs/PetApi.md#findPetsByStatus) | **GET** /pet/findByStatus | Finds Pets by status
*SwaggerPetstore.PetApi* | [**findPetsByTags**](docs/PetApi.md#findPetsByTags) | **GET** /pet/findByTags | Finds Pets by tags
*SwaggerPetstore.PetApi* | [**getPetById**](docs/PetApi.md#getPetById) | **GET** /pet/{petId} | Find pet by ID
*SwaggerPetstore.PetApi* | [**getPetByIdInObject**](docs/PetApi.md#getPetByIdInObject) | **GET** /pet/{petId}?response=inline_arbitrary_object | Fake endpoint to test inline arbitrary object return by &#39;Find pet by ID&#39;
*SwaggerPetstore.PetApi* | [**petPetIdtestingByteArraytrueGet**](docs/PetApi.md#petPetIdtestingByteArraytrueGet) | **GET** /pet/{petId}?testing_byte_array=true | Fake endpoint to test byte array return by &#39;Find pet by ID&#39;
*SwaggerPetstore.PetApi* | [**updatePet**](docs/PetApi.md#updatePet) | **PUT** /pet | Update an existing pet
*SwaggerPetstore.PetApi* | [**updatePetWithForm**](docs/PetApi.md#updatePetWithForm) | **POST** /pet/{petId} | Updates a pet in the store with form data
*SwaggerPetstore.PetApi* | [**uploadFile**](docs/PetApi.md#uploadFile) | **POST** /pet/{petId}/uploadImage | uploads an image
*SwaggerPetstore.StoreApi* | [**deleteOrder**](docs/StoreApi.md#deleteOrder) | **DELETE** /store/order/{orderId} | Delete purchase order by ID
*SwaggerPetstore.StoreApi* | [**findOrdersByStatus**](docs/StoreApi.md#findOrdersByStatus) | **GET** /store/findByStatus | Finds orders by status
*SwaggerPetstore.StoreApi* | [**getInventory**](docs/StoreApi.md#getInventory) | **GET** /store/inventory | Returns pet inventories by status
*SwaggerPetstore.StoreApi* | [**getInventoryInObject**](docs/StoreApi.md#getInventoryInObject) | **GET** /store/inventory?response=arbitrary_object | Fake endpoint to test arbitrary object return by &#39;Get inventory&#39;
*SwaggerPetstore.StoreApi* | [**getOrderById**](docs/StoreApi.md#getOrderById) | **GET** /store/order/{orderId} | Find purchase order by ID
*SwaggerPetstore.StoreApi* | [**placeOrder**](docs/StoreApi.md#placeOrder) | **POST** /store/order | Place an order for a pet
*SwaggerPetstore.UserApi* | [**createUser**](docs/UserApi.md#createUser) | **POST** /user | Create user
*SwaggerPetstore.UserApi* | [**createUsersWithArrayInput**](docs/UserApi.md#createUsersWithArrayInput) | **POST** /user/createWithArray | Creates list of users with given input array
*SwaggerPetstore.UserApi* | [**createUsersWithListInput**](docs/UserApi.md#createUsersWithListInput) | **POST** /user/createWithList | Creates list of users with given input array
*SwaggerPetstore.UserApi* | [**deleteUser**](docs/UserApi.md#deleteUser) | **DELETE** /user/{username} | Delete user
*SwaggerPetstore.UserApi* | [**getUserByName**](docs/UserApi.md#getUserByName) | **GET** /user/{username} | Get user by user name
*SwaggerPetstore.UserApi* | [**loginUser**](docs/UserApi.md#loginUser) | **GET** /user/login | Logs user into the system
*SwaggerPetstore.UserApi* | [**logoutUser**](docs/UserApi.md#logoutUser) | **GET** /user/logout | Logs out current logged in user session
*SwaggerPetstore.UserApi* | [**updateUser**](docs/UserApi.md#updateUser) | **PUT** /user/{username} | Updated user


## Documentation for Models

 - [SwaggerPetstore.Category](docs/Category.md)
 - [SwaggerPetstore.InlineResponse200](docs/InlineResponse200.md)
 - [SwaggerPetstore.ModelReturn](docs/ModelReturn.md)
 - [SwaggerPetstore.Name](docs/Name.md)
 - [SwaggerPetstore.Order](docs/Order.md)
 - [SwaggerPetstore.Pet](docs/Pet.md)
 - [SwaggerPetstore.SpecialModelName](docs/SpecialModelName.md)
 - [SwaggerPetstore.Tag](docs/Tag.md)
 - [SwaggerPetstore.User](docs/User.md)


## Documentation for Authorization


### petstore_auth

- **Type**: OAuth
- **Flow**: implicit
- **Authorizatoin URL**: http://petstore.swagger.io/api/oauth/dialog
- **Scopes**: 
  - write:pets: modify pets in your account
  - read:pets: read your pets

### test_api_client_id

- **Type**: API key
- **API key parameter name**: x-test_api_client_id
- **Location**: HTTP header

### test_api_client_secret

- **Type**: API key
- **API key parameter name**: x-test_api_client_secret
- **Location**: HTTP header

### api_key

- **Type**: API key
- **API key parameter name**: api_key
- **Location**: HTTP header

### test_http_basic

- **Type**: HTTP basic authentication

### test_api_key_query

- **Type**: API key
- **API key parameter name**: test_api_key_query
- **Location**: URL query string

### test_api_key_header

- **Type**: API key
- **API key parameter name**: test_api_key_header
- **Location**: HTTP header

